QGIS Application - Bug report #15771
@parent not linked to the correct feature when looping through layer
2016-10-27 09:25 PM - Mathieu Pellerin - nIRV

Status: Closed

Priority: Severe/Regression

Assignee: Matthias Kuhn

Category: Expressions

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 23693
Description

While testing out the cool new @parent variable for the aggregate() function, | noticed the @parent variable doesn't get assigned to the
correct feature when looping through a layer (as part of labelling or symbology rendering). I've attached a small test project which
demonstrate the issue.
Steps to reproduce

1. Open the parent.qgs test project

2. Take note of the label over the two orange areas

3. It should be showing the number of overlapping points, which it does properly only for the first feature (i.e. 3), while the second
feature also shows 3 when it should show 2.

4. The labels' second line show the @parent COMM_CODE value, which shows the wrong one for the second feature (it should be
123456, and instead it prints 12345)

Associated revisions

Revision e7333f68 - 2016-10-31 12:15 PM - Matthias Kuhn

[ogr] Ignore request limit if unable to compile expression

Fix #15771

Revision 5e3bef77 - 2016-11-02 12:52 AM - Nyall Dawson

Fix QgsFeatureRequest with expression not using provider fields
and limit (fix #15771)

Revision cfeeb3fd - 2016-11-23 04:11 AM - Nyall Dawson

Fix QgsFeatureRequest with expression not using provider fields
and limit (fix #15771)

(cherry-picked from 5e3bef7)

History

#1 - 2016-10-30 06:37 PM - Mathieu Pellerin - nIRV
- % Done changed from 0 to 50
- File parent_v2.zip added
This commit (#7a05a7a8c4b9184f6cad7d155b6714076b1dccd9) improved things (i.e. @parent's caching works, so is $geometry's), but caching is still
not updated for "fields" in the filter clause.

I'm attaching an updated test project, which labels two polygons using three aggregate calls, the third one being built on a "field" =
attribute(@parent,"parent_field) which fails for the 2nd polygon. The failure is due to "field" not being updated with the 2nd polygon's values.

#2 - 2016-10-31 04:16 AM - Anonymous
- Status changed from Open to Closed

Fixed in changeset commit:"e7333f68145f27a74aacd8f75939623e37fc4510".

Files
parent.zip 6.93 KB 2016-10-27 Mathieu Pellerin - nIRV
parent_v2.zip 7.16 KB 2016-10-30 Mathieu Pellerin - nIRV
